
var ServiceExakt = function(aId){	
	this.iUrl = window.location.protocol + "//" + window.location.host + "/" + aId + "/Exakt/control";
	this.iDomain = "av.openhome.org";
	if (this.iDomain == "upnp.org") {
		this.iDomain = "schemas.upnp.org";
    }
	this.iDomain = this.iDomain.replace(/\./,"-");
	this.iType = "Exakt";
	this.iVersion = "2";
	
	this.iVariables = {};
		this.iVariables["DeviceList"] = new ServiceVariable("DeviceList");
		this.iVariables["DeviceSettings"] = new ServiceVariable("DeviceSettings");
		this.iVariables["ConnectionStatus"] = new ServiceVariable("ConnectionStatus");
		this.iVariables["DeviceId"] = new ServiceVariable("DeviceId");
		this.iVariables["BankId"] = new ServiceVariable("BankId");
		this.iVariables["Persist"] = new ServiceVariable("Persist");
		this.iVariables["Mute"] = new ServiceVariable("Mute");
		this.iVariables["FileUri"] = new ServiceVariable("FileUri");
		this.iVariables["Version"] = new ServiceVariable("Version");
}


ServiceExakt.prototype.ServiceName = function(){
	return this.iType;
}

ServiceExakt.prototype.Variables = function(){
	return this.iVariables;
}

ServiceExakt.prototype.VariableNames = function(){
	var result = [];
	for (var variable in this.iVariables){
		if (this.iVariables.hasOwnProperty(variable)){
			result[result.length] = variable;
		}
	}
	return result;
}


ServiceExakt.prototype.DeviceList = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DeviceList", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["List"] = request.ReadStringParameter(result["List"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceExakt.prototype.DeviceSettings = function(DeviceId, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DeviceSettings", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("DeviceId", DeviceId);
    request.Send(function(result){
		result["Settings"] = request.ReadStringParameter(result["Settings"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceExakt.prototype.ConnectionStatus = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ConnectionStatus", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["ConnectionStatus"] = request.ReadStringParameter(result["ConnectionStatus"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceExakt.prototype.Set = function(DeviceId, BankId, FileUri, Mute, Persist, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Set", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("DeviceId", DeviceId);
    request.WriteIntParameter("BankId", BankId);
    request.WriteStringParameter("FileUri", FileUri);
    request.WriteBoolParameter("Mute", Mute);
    request.WriteBoolParameter("Persist", Persist);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceExakt.prototype.Reprogram = function(DeviceId, FileUri, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Reprogram", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("DeviceId", DeviceId);
    request.WriteStringParameter("FileUri", FileUri);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceExakt.prototype.ReprogramFallback = function(DeviceId, FileUri, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ReprogramFallback", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("DeviceId", DeviceId);
    request.WriteStringParameter("FileUri", FileUri);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceExakt.prototype.Version = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Version", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Version"] = request.ReadStringParameter(result["Version"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

