
var ServiceNetworkMonitor = function(aId){	
	this.iUrl = window.location.protocol + "//" + window.location.host + "/" + aId + "/NetworkMonitor/control";
	this.iDomain = "av.openhome.org";
	if (this.iDomain == "upnp.org") {
		this.iDomain = "schemas.upnp.org";
    }
	this.iDomain = this.iDomain.replace(/\./,"-");
	this.iType = "NetworkMonitor";
	this.iVersion = "1";
	
	this.iVariables = {};
		this.iVariables["Name"] = new ServiceVariable("Name");
		this.iVariables["Sender"] = new ServiceVariable("Sender");
		this.iVariables["Receiver"] = new ServiceVariable("Receiver");
		this.iVariables["Results"] = new ServiceVariable("Results");
}


ServiceNetworkMonitor.prototype.ServiceName = function(){
	return this.iType;
}

ServiceNetworkMonitor.prototype.Variables = function(){
	return this.iVariables;
}

ServiceNetworkMonitor.prototype.VariableNames = function(){
	var result = [];
	for (var variable in this.iVariables){
		if (this.iVariables.hasOwnProperty(variable)){
			result[result.length] = variable;
		}
	}
	return result;
}


ServiceNetworkMonitor.prototype.Name = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Name", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Name"] = request.ReadStringParameter(result["Name"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceNetworkMonitor.prototype.Ports = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Ports", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Sender"] = request.ReadIntParameter(result["Sender"]);	
		result["Receiver"] = request.ReadIntParameter(result["Receiver"]);	
		result["Results"] = request.ReadIntParameter(result["Results"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

