
var ServiceProxy = function(aId){	
	this.iUrl = window.location.protocol + "//" + window.location.host + "/" + aId + "/Proxy/control";
	this.iDomain = "linn.co.uk";
	if (this.iDomain == "upnp.org") {
		this.iDomain = "schemas.upnp.org";
    }
	this.iDomain = this.iDomain.replace(/\./,"-");
	this.iType = "Proxy";
	this.iVersion = "1";
	
	this.iVariables = {};
		this.iVariables["typeString"] = new ServiceVariable("typeString");
}


ServiceProxy.prototype.ServiceName = function(){
	return this.iType;
}

ServiceProxy.prototype.Variables = function(){
	return this.iVariables;
}

ServiceProxy.prototype.VariableNames = function(){
	var result = [];
	for (var variable in this.iVariables){
		if (this.iVariables.hasOwnProperty(variable)){
			result[result.length] = variable;
		}
	}
	return result;
}


ServiceProxy.prototype.SoftwareVersion = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SoftwareVersion", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSoftwareVersion"] = request.ReadStringParameter(result["aSoftwareVersion"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceProxy.prototype.HardwareVersion = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("HardwareVersion", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aHardwareVersion"] = request.ReadStringParameter(result["aHardwareVersion"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

