
var ServiceSdp = function(aId){	
	this.iUrl = window.location.protocol + "//" + window.location.host + "/" + aId + "/Sdp/control";
	this.iDomain = "linn.co.uk";
	if (this.iDomain == "upnp.org") {
		this.iDomain = "schemas.upnp.org";
    }
	this.iDomain = this.iDomain.replace(/\./,"-");
	this.iType = "Sdp";
	this.iVersion = "1";
	
	this.iVariables = {};
		this.iVariables["DiscType"] = new ServiceVariable("DiscType");
		this.iVariables["Title"] = new ServiceVariable("Title");
		this.iVariables["TrayState"] = new ServiceVariable("TrayState");
		this.iVariables["DiscState"] = new ServiceVariable("DiscState");
		this.iVariables["PlayState"] = new ServiceVariable("PlayState");
		this.iVariables["SearchType"] = new ServiceVariable("SearchType");
		this.iVariables["SearchSpeed"] = new ServiceVariable("SearchSpeed");
		this.iVariables["Track"] = new ServiceVariable("Track");
		this.iVariables["TrackElapsedTime"] = new ServiceVariable("TrackElapsedTime");
		this.iVariables["TrackRemainingTime"] = new ServiceVariable("TrackRemainingTime");
		this.iVariables["DiscElapsedTime"] = new ServiceVariable("DiscElapsedTime");
		this.iVariables["DiscRemainingTime"] = new ServiceVariable("DiscRemainingTime");
		this.iVariables["RepeatMode"] = new ServiceVariable("RepeatMode");
		this.iVariables["IntroMode"] = new ServiceVariable("IntroMode");
		this.iVariables["ProgramMode"] = new ServiceVariable("ProgramMode");
		this.iVariables["Domain"] = new ServiceVariable("Domain");
		this.iVariables["Angle"] = new ServiceVariable("Angle");
		this.iVariables["TotalAngles"] = new ServiceVariable("TotalAngles");
		this.iVariables["Subtitle"] = new ServiceVariable("Subtitle");
		this.iVariables["AudioTrack"] = new ServiceVariable("AudioTrack");
		this.iVariables["ZoomLevel"] = new ServiceVariable("ZoomLevel");
		this.iVariables["SetupMode"] = new ServiceVariable("SetupMode");
		this.iVariables["SacdState"] = new ServiceVariable("SacdState");
		this.iVariables["Slideshow"] = new ServiceVariable("Slideshow");
		this.iVariables["Error"] = new ServiceVariable("Error");
		this.iVariables["Orientation"] = new ServiceVariable("Orientation");
		this.iVariables["TotalTracks"] = new ServiceVariable("TotalTracks");
		this.iVariables["TotalTitles"] = new ServiceVariable("TotalTitles");
		this.iVariables["Encoding"] = new ServiceVariable("Encoding");
		this.iVariables["FileSize"] = new ServiceVariable("FileSize");
		this.iVariables["DiscId"] = new ServiceVariable("DiscId");
		this.iVariables["DiscLength"] = new ServiceVariable("DiscLength");
		this.iVariables["TrackLength"] = new ServiceVariable("TrackLength");
		this.iVariables["Genre"] = new ServiceVariable("Genre");
		this.iVariables["Year"] = new ServiceVariable("Year");
		this.iVariables["TrackName"] = new ServiceVariable("TrackName");
		this.iVariables["ArtistName"] = new ServiceVariable("ArtistName");
		this.iVariables["AlbumName"] = new ServiceVariable("AlbumName");
		this.iVariables["Comment"] = new ServiceVariable("Comment");
		this.iVariables["FileName"] = new ServiceVariable("FileName");
		this.iVariables["SystemCapabilities"] = new ServiceVariable("SystemCapabilities");
		this.iVariables["DiscCapabilities"] = new ServiceVariable("DiscCapabilities");
		this.iVariables["ZoomLevelInfo"] = new ServiceVariable("ZoomLevelInfo");
		this.iVariables["SubtitleInfo"] = new ServiceVariable("SubtitleInfo");
		this.iVariables["AudioTrackInfo"] = new ServiceVariable("AudioTrackInfo");
		this.iVariables["TableOfContents"] = new ServiceVariable("TableOfContents");
		this.iVariables["DirectoryStructure"] = new ServiceVariable("DirectoryStructure");
		this.iVariables["Time"] = new ServiceVariable("Time");
		this.iVariables["Seconds"] = new ServiceVariable("Seconds");
		this.iVariables["ProgramList"] = new ServiceVariable("ProgramList");
		this.iVariables["SkipType"] = new ServiceVariable("SkipType");
		this.iVariables["SelectionType"] = new ServiceVariable("SelectionType");
		this.iVariables["Index"] = new ServiceVariable("Index");
		this.iVariables["NavigationType"] = new ServiceVariable("NavigationType");
		this.iVariables["FileNameString"] = new ServiceVariable("FileNameString");
		this.iVariables["Password"] = new ServiceVariable("Password");
}

ServiceSdp.kDiscTypeUnsupportedDiscType = "Unsupported Disc Type";
ServiceSdp.kDiscTypeNoDisc = "No Disc";
ServiceSdp.kDiscTypeCd = "CD";
ServiceSdp.kDiscTypeVcd = "VCD";
ServiceSdp.kDiscTypeSvcd = "SVCD";
ServiceSdp.kDiscTypeSacd = "SACD";
ServiceSdp.kDiscTypeDvd = "DVD";
ServiceSdp.kDiscTypeDvdAudio = "DVD-Audio";
ServiceSdp.kDiscTypeDataDisc = "Data Disc";
ServiceSdp.kDiscTypeUnknown = "Unknown";
ServiceSdp.kTrayStateTrayOpen = "Tray Open";
ServiceSdp.kTrayStateTrayClosed = "Tray Closed";
ServiceSdp.kTrayStateTrayOpening = "Tray Opening";
ServiceSdp.kTrayStateTrayClosing = "Tray Closing";
ServiceSdp.kTrayStateUnknown = "Unknown";
ServiceSdp.kDiscStateDiscLoading = "Disc Loading";
ServiceSdp.kDiscStateDiscLoaded = "Disc Loaded";
ServiceSdp.kDiscStateUnknown = "Unknown";
ServiceSdp.kPlayStatePlaying = "Playing";
ServiceSdp.kPlayStateStopped = "Stopped";
ServiceSdp.kPlayStatePaused = "Paused";
ServiceSdp.kPlayStateSuspended = "Suspended";
ServiceSdp.kPlayStateUnknown = "Unknown";
ServiceSdp.kSearchTypeNone = "None";
ServiceSdp.kSearchTypeFastForward = "Fast Forward";
ServiceSdp.kSearchTypeFastReverse = "Fast Reverse";
ServiceSdp.kSearchTypeSlowForward = "Slow Forward";
ServiceSdp.kSearchTypeSlowReverse = "Slow Reverse";
ServiceSdp.kRepeatModeOff = "Off";
ServiceSdp.kRepeatModeAll = "All";
ServiceSdp.kRepeatModeTrack = "Track";
ServiceSdp.kRepeatModeAB = "A-B";
ServiceSdp.kProgramModeOff = "Off";
ServiceSdp.kProgramModeRandom = "Random";
ServiceSdp.kProgramModeShuffle = "Shuffle";
ServiceSdp.kProgramModeStored = "Stored";
ServiceSdp.kDomainNone = "None";
ServiceSdp.kDomainRootMenu = "Root Menu";
ServiceSdp.kDomainTitleMenu = "Title Menu";
ServiceSdp.kDomainCopyright = "Copyright";
ServiceSdp.kDomainPassword = "Password";
ServiceSdp.kZoomLevel25 = "25";
ServiceSdp.kZoomLevel50 = "50";
ServiceSdp.kZoomLevel100 = "100";
ServiceSdp.kZoomLevel150 = "150";
ServiceSdp.kZoomLevel200 = "200";
ServiceSdp.kZoomLevel300 = "300";
ServiceSdp.kSacdStateUnknown = "Unknown";
ServiceSdp.kSacdStateDsdMultiChannel = "DSD Multi Channel";
ServiceSdp.kSacdStateDsdStereo = "DSD Stereo";
ServiceSdp.kSacdStateCddaStereo = "CDDA Stereo";
ServiceSdp.kSacdStateSelecting = "Selecting";
ServiceSdp.kSlideshowOff = "Off";
ServiceSdp.kSlideshowSlideShow = "Slide Show";
ServiceSdp.kSlideshowSlideShowPhotoPerTrack = "Slide Show (Photo Per Track)";
ServiceSdp.kSlideshowNewWipeMode = "New Wipe Mode";
ServiceSdp.kSlideshowThumbnails = "Thumbnails";
ServiceSdp.kErrorNone = "None";
ServiceSdp.kErrorTrackOutOfRange = "Track out of Range";
ServiceSdp.kErrorTitleOutOfRange = "Title out of Range";
ServiceSdp.kErrorTimeOutOfRange = "Time out of Range";
ServiceSdp.kErrorResumeNotAvailable = "Resume Not Available";
ServiceSdp.kErrorProgramSizeInvalid = "Program Size Invalid";
ServiceSdp.kErrorDomainNotAvailable = "Domain Not Available";
ServiceSdp.kErrorSearchTypeNotAvailable = "Search Type Not Available";
ServiceSdp.kErrorProgramTypeNotAvailable = "Program Type Not Available";
ServiceSdp.kErrorRepeatTypeNotAvailable = "Repeat Type Not Available";
ServiceSdp.kErrorIntroModeNotAvailable = "Intro Mode Not Available";
ServiceSdp.kErrorSkipTypeNotAvailable = "Skip Type Not Available";
ServiceSdp.kErrorSetupModeNotAvailable = "Setup Mode Not Available";
ServiceSdp.kErrorAngleNotAvailable = "Angle Not Available";
ServiceSdp.kErrorSubtitleNotAvailable = "Subtitle Not Available";
ServiceSdp.kErrorZoomLevelNotAvailable = "Zoom Level Not Available";
ServiceSdp.kErrorAudioTrackNotAvailable = "Audio Track Not Available";
ServiceSdp.kErrorSacdLayerNotAvailable = "Sacd Layer Not Available";
ServiceSdp.kErrorInvalidNavigationRequest = "Invalid Navigation Request";
ServiceSdp.kErrorSlideShowTypeNotAvailable = "Slide Show Type Not Available";
ServiceSdp.kErrorRequestNotSupported = "Request Not Supported";
ServiceSdp.kErrorTableOfContentsMissing = "Table Of Contents Missing";
ServiceSdp.kErrorInvalidPassword = "Invalid Password";
ServiceSdp.kOrientationUnknown = "Unknown";
ServiceSdp.kOrientation0Degrees = "0 Degrees";
ServiceSdp.kOrientation0DegreesYMirror = "0 Degrees (Y Mirror)";
ServiceSdp.kOrientation90Degrees = "90 Degrees";
ServiceSdp.kOrientation90DegreesYMirror = "90 Degrees (Y Mirror)";
ServiceSdp.kOrientation180Degrees = "180 Degrees";
ServiceSdp.kOrientation180DegreesYMirror = "180 Degrees (Y Mirror)";
ServiceSdp.kOrientation270Degrees = "270 Degrees";
ServiceSdp.kOrientation270DegreesYMirror = "270 Degrees (Y Mirror)";
ServiceSdp.kSkipTypeSkipTrack = "SkipTrack";
ServiceSdp.kSkipTypeSkipFrame = "SkipFrame";
ServiceSdp.kSkipTypeSkipSearchSpeed = "SkipSearchSpeed";
ServiceSdp.kSkipTypeSkipFile = "SkipFile";
ServiceSdp.kSkipTypeSkipDisc = "SkipDisc";
ServiceSdp.kSkipTypeSkipSacdLayer = "SkipSacdLayer";
ServiceSdp.kSelectionTypeSelectDefault = "SelectDefault";
ServiceSdp.kSelectionTypeSelectNext = "SelectNext";
ServiceSdp.kSelectionTypeSelectPrev = "SelectPrev";
ServiceSdp.kSelectionTypeSelectIndex = "SelectIndex";
ServiceSdp.kNavigationTypeUp = "Up";
ServiceSdp.kNavigationTypeDown = "Down";
ServiceSdp.kNavigationTypeLeft = "Left";
ServiceSdp.kNavigationTypeRight = "Right";
ServiceSdp.kNavigationTypeSelect = "Select";
ServiceSdp.kNavigationTypeReturn = "Return";

ServiceSdp.prototype.ServiceName = function(){
	return this.iType;
}

ServiceSdp.prototype.Variables = function(){
	return this.iVariables;
}

ServiceSdp.prototype.VariableNames = function(){
	var result = [];
	for (var variable in this.iVariables){
		if (this.iVariables.hasOwnProperty(variable)){
			result[result.length] = variable;
		}
	}
	return result;
}


ServiceSdp.prototype.Open = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Open", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Close = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Close", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Play = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Play", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Stop = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Stop", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Pause = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Pause", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Resume = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Resume", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Search = function(aSearchType, aSearchSpeed, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Search", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSearchType", aSearchType);
    request.WriteIntParameter("aSearchSpeed", aSearchSpeed);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetTrack = function(aTrack, aTitle, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetTrack", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteIntParameter("aTrack", aTrack);
    request.WriteIntParameter("aTitle", aTitle);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetTime = function(aTime, aTitle, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetTime", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aTime", aTime);
    request.WriteIntParameter("aTitle", aTitle);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetProgramOff = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetProgramOff", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetProgramInclude = function(aIncludeList, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetProgramInclude", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteBinaryParameter("aIncludeList", aIncludeList);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetProgramExclude = function(aExcludeList, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetProgramExclude", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteBinaryParameter("aExcludeList", aExcludeList);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetProgramRandom = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetProgramRandom", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetProgramShuffle = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetProgramShuffle", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetRepeatOff = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetRepeatOff", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetRepeatAll = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetRepeatAll", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetRepeatTrack = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetRepeatTrack", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetRepeatAb = function(aStartTime, aEndTime, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetRepeatAb", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aStartTime", aStartTime);
    request.WriteStringParameter("aEndTime", aEndTime);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetIntroMode = function(aIntroMode, aOffset, aSeconds, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetIntroMode", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteBoolParameter("aIntroMode", aIntroMode);
    request.WriteIntParameter("aOffset", aOffset);
    request.WriteIntParameter("aSeconds", aSeconds);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetNext = function(aSkip, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetNext", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSkip", aSkip);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetPrev = function(aSkip, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetPrev", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSkip", aSkip);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.RootMenu = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("RootMenu", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TitleMenu = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TitleMenu", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetSetupMode = function(aSetupMode, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetSetupMode", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteBoolParameter("aSetupMode", aSetupMode);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetAngle = function(aSelect, aIndex, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetAngle", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSelect", aSelect);
    request.WriteIntParameter("aIndex", aIndex);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetAudioTrack = function(aSelect, aIndex, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetAudioTrack", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSelect", aSelect);
    request.WriteIntParameter("aIndex", aIndex);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetSubtitle = function(aSelect, aIndex, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetSubtitle", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSelect", aSelect);
    request.WriteIntParameter("aIndex", aIndex);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetZoom = function(aSelect, aIndex, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetZoom", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSelect", aSelect);
    request.WriteIntParameter("aIndex", aIndex);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetSacdLayer = function(aSacdLayer, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetSacdLayer", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSacdLayer", aSacdLayer);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Navigate = function(aNavigation, aIndex, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Navigate", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aNavigation", aNavigation);
    request.WriteIntParameter("aIndex", aIndex);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetSlideshow = function(aSlideshow, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetSlideshow", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aSlideshow", aSlideshow);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetPassword = function(aPassword, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetPassword", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aPassword", aPassword);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DiscType = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DiscType", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDiscType"] = request.ReadStringParameter(result["aDiscType"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Title = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Title", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTitle"] = request.ReadIntParameter(result["aTitle"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TrayState = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TrayState", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTrayState"] = request.ReadStringParameter(result["aTrayState"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DiscState = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DiscState", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDiscState"] = request.ReadStringParameter(result["aDiscState"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.PlayState = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("PlayState", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aPlayState"] = request.ReadStringParameter(result["aPlayState"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SearchType = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SearchType", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSearchType"] = request.ReadStringParameter(result["aSearchType"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SearchSpeed = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SearchSpeed", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSearchSpeed"] = request.ReadIntParameter(result["aSearchSpeed"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Track = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Track", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTrack"] = request.ReadIntParameter(result["aTrack"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TrackElapsedTime = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TrackElapsedTime", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTrackElapsedTime"] = request.ReadStringParameter(result["aTrackElapsedTime"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TrackRemainingTime = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TrackRemainingTime", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTrackRemainingTime"] = request.ReadStringParameter(result["aTrackRemainingTime"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DiscElapsedTime = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DiscElapsedTime", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDiscElapsedTime"] = request.ReadStringParameter(result["aDiscElapsedTime"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DiscRemainingTime = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DiscRemainingTime", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDiscRemainingTime"] = request.ReadStringParameter(result["aDiscRemainingTime"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.RepeatMode = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("RepeatMode", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aRepeatMode"] = request.ReadStringParameter(result["aRepeatMode"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.IntroMode = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("IntroMode", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aIntroMode"] = request.ReadBoolParameter(result["aIntroMode"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.ProgramMode = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ProgramMode", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aProgramMode"] = request.ReadStringParameter(result["aProgramMode"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Domain = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Domain", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDomain"] = request.ReadStringParameter(result["aDomain"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Angle = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Angle", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aAngle"] = request.ReadIntParameter(result["aAngle"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TotalAngles = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TotalAngles", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTotalAngles"] = request.ReadIntParameter(result["aTotalAngles"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Subtitle = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Subtitle", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSubtitle"] = request.ReadIntParameter(result["aSubtitle"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.AudioTrack = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("AudioTrack", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aAudioTrack"] = request.ReadIntParameter(result["aAudioTrack"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.ZoomLevel = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ZoomLevel", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aZoomLevel"] = request.ReadStringParameter(result["aZoomLevel"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SetupMode = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetupMode", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSetupMode"] = request.ReadBoolParameter(result["aSetupMode"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SacdState = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SacdState", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSacdState"] = request.ReadStringParameter(result["aSacdState"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Slideshow = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Slideshow", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSlideshow"] = request.ReadStringParameter(result["aSlideshow"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Error = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Error", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aError"] = request.ReadStringParameter(result["aError"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Orientation = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Orientation", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aOrientation"] = request.ReadStringParameter(result["aOrientation"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DiscLength = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DiscLength", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDiscLength"] = request.ReadStringParameter(result["aDiscLength"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TrackLength = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TrackLength", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTrackLength"] = request.ReadStringParameter(result["aTrackLength"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TotalTracks = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TotalTracks", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTotalTracks"] = request.ReadIntParameter(result["aTotalTracks"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TotalTitles = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TotalTitles", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTotalTitles"] = request.ReadIntParameter(result["aTotalTitles"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Genre = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Genre", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aGenre"] = request.ReadStringParameter(result["aGenre"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Encoding = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Encoding", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aEncoding"] = request.ReadIntParameter(result["aEncoding"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.FileSize = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("FileSize", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aFileSize"] = request.ReadIntParameter(result["aFileSize"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DiscId = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DiscId", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDiscId"] = request.ReadIntParameter(result["aDiscId"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Year = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Year", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aYear"] = request.ReadStringParameter(result["aYear"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TrackName = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TrackName", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTrackName"] = request.ReadStringParameter(result["aTrackName"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.ArtistName = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ArtistName", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aArtistName"] = request.ReadStringParameter(result["aArtistName"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.AlbumName = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("AlbumName", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aAlbumName"] = request.ReadStringParameter(result["aAlbumName"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.Comment = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Comment", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aComment"] = request.ReadStringParameter(result["aComment"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.FileName = function(aIndex, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("FileName", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteIntParameter("aIndex", aIndex);
    request.Send(function(result){
		result["aFileName"] = request.ReadStringParameter(result["aFileName"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SystemCapabilities = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SystemCapabilities", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSystemCapabilities"] = request.ReadBinaryParameter(result["aSystemCapabilities"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DiscCapabilities = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DiscCapabilities", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDiscCapabilities"] = request.ReadBinaryParameter(result["aDiscCapabilities"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.ZoomLevelInfo = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ZoomLevelInfo", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aZoomLevelInfo"] = request.ReadBinaryParameter(result["aZoomLevelInfo"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.SubtitleInfo = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SubtitleInfo", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aSubtitleInfo"] = request.ReadBinaryParameter(result["aSubtitleInfo"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.AudioTrackInfo = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("AudioTrackInfo", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aAudioTrackInfo"] = request.ReadBinaryParameter(result["aAudioTrackInfo"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.TableOfContents = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("TableOfContents", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aTableOfContents"] = request.ReadBinaryParameter(result["aTableOfContents"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSdp.prototype.DirectoryStructure = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("DirectoryStructure", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["aDirectoryStructure"] = request.ReadBinaryParameter(result["aDirectoryStructure"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

