
var ServiceSender = function(aId){	
	this.iUrl = window.location.protocol + "//" + window.location.host + "/" + aId + "/Sender/control";
	this.iDomain = "av.openhome.org";
	if (this.iDomain == "upnp.org") {
		this.iDomain = "schemas.upnp.org";
    }
	this.iDomain = this.iDomain.replace(/\./,"-");
	this.iType = "Sender";
	this.iVersion = "1";
	
	this.iVariables = {};
		this.iVariables["PresentationUrl"] = new ServiceVariable("PresentationUrl");
		this.iVariables["Metadata"] = new ServiceVariable("Metadata");
		this.iVariables["Audio"] = new ServiceVariable("Audio");
		this.iVariables["Status"] = new ServiceVariable("Status");
		this.iVariables["Attributes"] = new ServiceVariable("Attributes");
}

ServiceSender.kStatusEnabled = "Enabled";
ServiceSender.kStatusDisabled = "Disabled";
ServiceSender.kStatusBlocked = "Blocked";

ServiceSender.prototype.ServiceName = function(){
	return this.iType;
}

ServiceSender.prototype.Variables = function(){
	return this.iVariables;
}

ServiceSender.prototype.VariableNames = function(){
	var result = [];
	for (var variable in this.iVariables){
		if (this.iVariables.hasOwnProperty(variable)){
			result[result.length] = variable;
		}
	}
	return result;
}


ServiceSender.prototype.PresentationUrl = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("PresentationUrl", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadStringParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSender.prototype.Metadata = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Metadata", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadStringParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSender.prototype.Audio = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Audio", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadBoolParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSender.prototype.Status = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Status", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadStringParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceSender.prototype.Attributes = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Attributes", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadStringParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

