
var ServiceVideo = function(aId){	
	this.iUrl = window.location.protocol + "//" + window.location.host + "/" + aId + "/Video/control";
	this.iDomain = "linn.co.uk";
	if (this.iDomain == "upnp.org") {
		this.iDomain = "schemas.upnp.org";
    }
	this.iDomain = this.iDomain.replace(/\./,"-");
	this.iType = "Video";
	this.iVersion = "1";
	
	this.iVariables = {};
		this.iVariables["DeinterlacerInputSyncs"] = new ServiceVariable("DeinterlacerInputSyncs");
		this.iVariables["Resolution"] = new ServiceVariable("Resolution");
		this.iVariables["DeinterlacerPassThrough"] = new ServiceVariable("DeinterlacerPassThrough");
		this.iVariables["ScalerPassThrough"] = new ServiceVariable("ScalerPassThrough");
		this.iVariables["ColourSpace"] = new ServiceVariable("ColourSpace");
		this.iVariables["AspectRatio"] = new ServiceVariable("AspectRatio");
}

ServiceVideo.kDeinterlacerInputSyncsSyncEmbedded = "SyncEmbedded";
ServiceVideo.kDeinterlacerInputSyncsSyncSeparate = "SyncSeparate";
ServiceVideo.kResolutionResolutionVga = "ResolutionVga";
ServiceVideo.kResolutionResolution480I = "Resolution480i";
ServiceVideo.kResolutionResolution576I = "Resolution576i";
ServiceVideo.kResolutionResolution480P = "Resolution480p";
ServiceVideo.kResolutionResolution576P = "Resolution576p";
ServiceVideo.kResolutionResolution720P = "Resolution720p";
ServiceVideo.kResolutionResolution1080I = "Resolution1080i";
ServiceVideo.kResolutionResolution1080P = "Resolution1080p";
ServiceVideo.kColourSpaceColourSpaceYcbCr422 = "ColourSpaceYCbCr422";
ServiceVideo.kColourSpaceColourSpaceYcbCr444 = "ColourSpaceYCbCr444";
ServiceVideo.kColourSpaceColourSpaceRgb = "ColourSpaceRgb";
ServiceVideo.kAspectRatioAspectRatio4By3 = "AspectRatio4By3";
ServiceVideo.kAspectRatioAspectRatio16By9 = "AspectRatio16By9";
ServiceVideo.kAspectRatioLetterBox = "LetterBox";

ServiceVideo.prototype.ServiceName = function(){
	return this.iType;
}

ServiceVideo.prototype.Variables = function(){
	return this.iVariables;
}

ServiceVideo.prototype.VariableNames = function(){
	var result = [];
	for (var variable in this.iVariables){
		if (this.iVariables.hasOwnProperty(variable)){
			result[result.length] = variable;
		}
	}
	return result;
}


ServiceVideo.prototype.ResetDeinterlacer = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ResetDeinterlacer", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetDeinterlacerInputSyncs = function(aInputSync, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetDeinterlacerInputSyncs", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aInputSync", aInputSync);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetDeinterlacerInputResolution = function(aResolution, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetDeinterlacerInputResolution", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aResolution", aResolution);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetDeinterlacerPassThrough = function(aPassThrough, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetDeinterlacerPassThrough", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteBoolParameter("aPassThrough", aPassThrough);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.ResetScaler = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("ResetScaler", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetScalerPassThrough = function(aPassThrough, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetScalerPassThrough", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteBoolParameter("aPassThrough", aPassThrough);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetScalerInputResolution = function(aResolution, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetScalerInputResolution", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aResolution", aResolution);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetScalerOutputResolution = function(aResolution, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetScalerOutputResolution", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aResolution", aResolution);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetScalerOutputColourSpace = function(aColourSpace, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetScalerOutputColourSpace", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aColourSpace", aColourSpace);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVideo.prototype.SetScalerAspectRatio = function(aAspectRatio, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetScalerAspectRatio", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteStringParameter("aAspectRatio", aAspectRatio);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

