
var ServiceVolume = function(aId){	
	this.iUrl = window.location.protocol + "//" + window.location.host + "/" + aId + "/Volume/control";
	this.iDomain = "av.openhome.org";
	if (this.iDomain == "upnp.org") {
		this.iDomain = "schemas.upnp.org";
    }
	this.iDomain = this.iDomain.replace(/\./,"-");
	this.iType = "Volume";
	this.iVersion = "1";
	
	this.iVariables = {};
		this.iVariables["Volume"] = new ServiceVariable("Volume");
		this.iVariables["Mute"] = new ServiceVariable("Mute");
		this.iVariables["Balance"] = new ServiceVariable("Balance");
		this.iVariables["Fade"] = new ServiceVariable("Fade");
		this.iVariables["VolumeLimit"] = new ServiceVariable("VolumeLimit");
		this.iVariables["VolumeMax"] = new ServiceVariable("VolumeMax");
		this.iVariables["VolumeUnity"] = new ServiceVariable("VolumeUnity");
		this.iVariables["VolumeSteps"] = new ServiceVariable("VolumeSteps");
		this.iVariables["VolumeMilliDbPerStep"] = new ServiceVariable("VolumeMilliDbPerStep");
		this.iVariables["BalanceMax"] = new ServiceVariable("BalanceMax");
		this.iVariables["FadeMax"] = new ServiceVariable("FadeMax");
}


ServiceVolume.prototype.ServiceName = function(){
	return this.iType;
}

ServiceVolume.prototype.Variables = function(){
	return this.iVariables;
}

ServiceVolume.prototype.VariableNames = function(){
	var result = [];
	for (var variable in this.iVariables){
		if (this.iVariables.hasOwnProperty(variable)){
			result[result.length] = variable;
		}
	}
	return result;
}


ServiceVolume.prototype.Characteristics = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Characteristics", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["VolumeMax"] = request.ReadIntParameter(result["VolumeMax"]);	
		result["VolumeUnity"] = request.ReadIntParameter(result["VolumeUnity"]);	
		result["VolumeSteps"] = request.ReadIntParameter(result["VolumeSteps"]);	
		result["VolumeMilliDbPerStep"] = request.ReadIntParameter(result["VolumeMilliDbPerStep"]);	
		result["BalanceMax"] = request.ReadIntParameter(result["BalanceMax"]);	
		result["FadeMax"] = request.ReadIntParameter(result["FadeMax"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.SetVolume = function(Value, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetVolume", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteIntParameter("Value", Value);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.VolumeInc = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("VolumeInc", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.VolumeDec = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("VolumeDec", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.Volume = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Volume", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadIntParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.SetBalance = function(Value, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetBalance", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteIntParameter("Value", Value);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.BalanceInc = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("BalanceInc", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.BalanceDec = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("BalanceDec", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.Balance = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Balance", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadIntParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.SetFade = function(Value, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetFade", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteIntParameter("Value", Value);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.FadeInc = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("FadeInc", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.FadeDec = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("FadeDec", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.Fade = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Fade", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadIntParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.SetMute = function(Value, aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("SetMute", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.WriteBoolParameter("Value", Value);
    request.Send(function(result){
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.Mute = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("Mute", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadBoolParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

ServiceVolume.prototype.VolumeLimit = function(aSuccessFunction, aErrorFunction){	
	var request = new SoapRequest("VolumeLimit", this.iUrl, this.iDomain, this.iType, this.iVersion);		
    request.Send(function(result){
		result["Value"] = request.ReadIntParameter(result["Value"]);	
	
		if (aSuccessFunction){
			aSuccessFunction(result);
		}
	}, function(message, transport) {
		if (aErrorFunction) {aErrorFunction(message, transport);}
	});
}
    

